#!/bin/env python

import os, shutil, getopt, sys, string, commands

def copy_dir (todir,rootdir,listdir):
   for dir in listdir :
      rdir = rootdir + "/" + dir[0] + "/"
      tdir = todir + "/" + dir[0] + "/"
      if len(dir) == 1 :
         parentdir = os.path.split(tdir)[0]
         if not os.path.exists(parentdir) : shutil.copytree(rdir,parentdir)
      else :
         if not os.path.exists(tdir): os.system("/bin/mkdir -p "+tdir)
         for subdir in dir[1:] :
             f2dir = rdir+subdir
             t2dir = tdir+subdir
             if '*' in subdir:
                #files = os.listdir(rdir)
                list_files = commands.getoutput("ls -1 %s " % f2dir)
                files = list_files.split("\n")
                for file in files:
                   if os.path.exists(file) :
                      if os.path.isfile(file) :
                         base_file = os.path.split(file)[1]
                         shutil.copyfile(file,tdir+base_file)
                         shutil.copymode(file,tdir+base_file)
                         print "copy ",file," to ",tdir+base_file
             else :
                print "copy only ",f2dir, " to ",t2dir
                if os.path.exists(t2dir) : continue
                if os.path.isdir(f2dir): 
                   parent2dir = os.path.split(t2dir)[0]
                   if not os.path.exists(parent2dir) :
                      os.system("/bin/mkdir -p "+parent2dir)
                      shutil.copytree(f2dir,parent2dir)
                      shutil.copymode(f2dir,parent2dir)
                   else :
                      shutil.copytree(f2dir,t2dir)
                      shutil.copymode(f2dir,t2dir)
                elif os.path.isfile(f2dir): 
                   shutil.copyfile(f2dir,t2dir)
                   shutil.copymode(f2dir,t2dir)

# Usage function
def usage():
   print ''
   print 'create_tar.py -f from_dir -t to_dir -l listing -i -h'
   print ' -f from_dir : input directory (default is current directory)'
   print ' -t to_dir   : location of the output directory (default is current directory)'
   print ' -l listing  : location of file containing the list of files to be copied'
   print ' -i          : the user enters the file listing by keyboard'
   print ' -h          : print out the usage'
   print ''
   sys.exit(0)

#  ------------ top of main program -------------
# Decode the input arguments
opts,args = getopt.getopt(sys.argv[1:],'f:t:l:ih')
fromdir = os.getcwd()
todir = os.getcwd()
input = 0
use_default = 1
list_files = []
for (key,value) in opts:
   if key == '-f' : fromdir = value
   if key == '-t' : todir   = value
   if key == '-l' : 
      use_default = 0
      for line in open(value,'r').readlines():
         nline = string.split(string.strip(line))
         list_files.append(nline)
   if key == '-i' : 
      use_default = 0
      for line in sys.stdin.readlines():
         nline = string.split(string.strip(line))
         list_files.append(nline)
   if key == '-h' : usage()

# Read in the list of directories, files to be copied if input = 1
if use_default == 1:
   # Default list for releasing binary level 1A + level 1B
   list_files = [  \
               [".", "Common.cshrc"],\
               ["STORE/mcf", "*.mcf"],\
               ["STORE/pcf", "L1A*.pcf"],\
               ["STORE/pcf", "L1B*.pcf"],\
               ["STORE/pge_scripts", "L1A.ksh", "L1B_AIRS.ksh", "L1B_AMSU.ksh",  "L1B_HSB.ksh", "L1B_VIS.ksh"],\
               ["STORE/ancillary", "L1A*"],\
               ["STORE/ancillary", "L1B*"],\
               ["STORE/ancillary", "L2*chan*"],\
               [os.environ['ARCH'], "message"],\
               [os.environ['ARCH']+"/bin", "run_aggregate_final", "run_level_1A", "run_level_1B_amsu"],\
               [os.environ['ARCH']+"/bin", "run_level_1B_hsb", "run_level_1B_airs", "run_level_1B_vis"],\
               [os.environ['ARCH']+"/bin", "run_swath2text", "run_diffswath"],\
               [os.environ['ARCH']+"/bin", "run_scan_packets", "run_edos3_shift", "run_edos4", "run_TAIandUTC"],\
               [os.environ['ARCH']+"/bin", "run_retcode_msg"],\
             ]
# Print out the list
for line in list_files:
   print line

copy_dir(todir,fromdir,list_files)
print "End of program "
