
#------------------------------------------------------------------------------
#
# 1. DISCLAIMER
#    THE SOFTWARE AND/OR RELATED MATERIALS ARE PROVIDED "AS-IS" WITHOUT
#    WARRANTY OF ANY KIND INCLUDING ANY WARRANTIES OF PERFORMANCE OR
#    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE OR PURPOSE (AS SET FORTH
#    IN UCC 2312-2313) OR FOR ANY PURPOSE WHATSOEVER, FOR THE LICENSED
#    PRODUCT, HOWEVER USED.
#
#    IN NO EVENT SHALL CALTECH/JPL BE LIABLE FOR ANY DAMAGES AND/OR COSTS,
#    INCLUDING BUT NOT LIMITED TO INCIDENTAL OR CONSEQUENTIAL DAMAGES OF ANY
#    KIND, INCLUDING ECONOMIC DAMAGE OR INJURY TO PROPERTY AND LOST PROFITS,
#    REGARDLESS OF WHETHER CIT/JPL SHALL BE ADVISED, HAVE REASON TO KNOW,
#    OR IN FACT SHALL KNOW OF THE POSSIBILITY.
#
#    USER BEARS ALL RISK RELATING TO QUALITY AND PERFORMANCE OF THE SOFTWARE
#    AND/OR RELATED MATERIALS.
#
# 2. The user shall comply with all applicable U.S. export control laws and
#    regulations.  To the extent that the software is subject to U.S. export
#    control laws and regulations, the user has the responsibility to obtain
#    export licenses or other export authority as may be required before
#    exporting such information to foreign countries or providing access to
#    foreign persons.
#
#------------------------------------------------------------------------------

#########################################################################
# File Name: expnset.py
# Date: original version written on 14 May 2002
# Description:
# Change Log:
# Date		Change By	Description
# --------	---------	-----------------------------------------
# 05/14/02	RAF		Original version written
#########################################################################
import pcf, esdt, os

class ExpSet:
   def __init__(self, pth, pcf_line, list, Fld):
      version = len(list)
      junk = pcf.PCF_LINE(pcf_line)
      self.Path = pth
      self.LID = junk.getLID()
      self.pcfList = []
      self.PrimaryFld = Fld
      for item in list:
         newLine = pcf.PCF_LINE(pcf_line)
	 newLine.clearComment()
	 newLine.repFld(Fld, item)
	 vFld = newLine.getVersionField()
	 newLine.repFld(vFld, `version`)
	 version = version - 1
	 self.pcfList.append(newLine)

   def getLid(self):
      return self.LID

   def getList(self):
      return self.pcfList

   def setPathFld(self, Fld):
      if (self.Path != ''):
         for x in range (len(self.pcfList)):
	    self.pcfList[x].repFld(Fld, self.Path)

   def setLGIDFld(self, Fld):
      if (esdt.ESDT_TBL.has_key(self.LID)):
         for x in range (len(self.pcfList)):
	    Name = self.pcfList[x].getFld(self.PrimaryFld)
	    self.pcfList[x].repFld(Fld, esdt.ESDT_TBL[self.LID].gen_LGID_Name(Name))

   def setMetaFld(self, FORCE=0):
      for x in range(len(self.pcfList)):
         Name = self.pcfList[x].getFld(self.PrimaryFld)
	 MetName = Name+'.met'
	 if (os.path.exists(os.path.join(self.Path, MetName)) or FORCE):
	    mFld = self.pcfList[x].getVersionField() - 1
	    self.pcfList[x].repFld(mFld, MetName)

   def getExpList(self):
      Results = []
      for x in range (len(self.pcfList)):
         Results.append(self.pcfList[x])
      return Results
