#!/usr/bin/env python

#------------------------------------------------------------------------------
#
# 1. DISCLAIMER
#    THE SOFTWARE AND/OR RELATED MATERIALS ARE PROVIDED "AS-IS" WITHOUT
#    WARRANTY OF ANY KIND INCLUDING ANY WARRANTIES OF PERFORMANCE OR
#    MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE OR PURPOSE (AS SET FORTH
#    IN UCC 2312-2313) OR FOR ANY PURPOSE WHATSOEVER, FOR THE LICENSED
#    PRODUCT, HOWEVER USED.
#
#    IN NO EVENT SHALL CALTECH/JPL BE LIABLE FOR ANY DAMAGES AND/OR COSTS,
#    INCLUDING BUT NOT LIMITED TO INCIDENTAL OR CONSEQUENTIAL DAMAGES OF ANY
#    KIND, INCLUDING ECONOMIC DAMAGE OR INJURY TO PROPERTY AND LOST PROFITS,
#    REGARDLESS OF WHETHER CIT/JPL SHALL BE ADVISED, HAVE REASON TO KNOW,
#    OR IN FACT SHALL KNOW OF THE POSSIBILITY.
#
#    USER BEARS ALL RISK RELATING TO QUALITY AND PERFORMANCE OF THE SOFTWARE
#    AND/OR RELATED MATERIALS.
#
# 2. The user shall comply with all applicable U.S. export control laws and
#    regulations.  To the extent that the software is subject to U.S. export
#    control laws and regulations, the user has the responsibility to obtain
#    export licenses or other export authority as may be required before
#    exporting such information to foreign countries or providing access to
#    foreign persons.
#
#------------------------------------------------------------------------------


import string

def scanODL (filen):
   Content = {}
   Lines = open(filen,'r').readlines()
   Cur_Name = []
   Cur_Value = ""
   iclass = ""
   for Idx in range(len(Lines)):
      Line = string.strip(Lines[Idx])  # take away the eol
      if (len(Line) > 0) :
         Fields = string.split(Line,'=',2)
         Key = string.lstrip(Fields[0])
         Key = string.rstrip(Key)
         Key = string.replace(Key,'"','')
         Bkey = string.upper(Key)
         #print "DEBUG: number of element=", len(Fields)

         if  len(Fields) < 2 :
            Cur_Value = Cur_Value + Key 
         else:
             Value = string.lstrip(Fields[1])
             Value = string.rstrip(Value)
             Value = string.replace(Value,'"','')
             #print "DEBUG ",Key," Value=",Value
          
             if  Bkey == 'GROUP' :
                Cur_Name.append(string.upper(Value))
             elif  Bkey == 'END_GROUP' :
                #while ( Cur_Name[-1] != Value ):
                #   Cur_Name.pop()
                Cur_Name.pop()
             elif  Bkey == 'CLASS' :
                #Cur_Name[-1]= Cur_Name[-1]+'|'+string.replace(Value,'"','')
                #Cur_Name.append(string.replace(Value,'"',''))
                iclass = string.replace(Value,'"','')
             elif  Bkey == 'OBJECT' :
                Cur_Name.append(Value)
             elif  Bkey == 'END_OBJECT' :
                if  Cur_Value != "":
                   new_obj = string.join(Cur_Name,'.')
                   if ( Content.has_key(new_obj) ):
                        new_obj = new_obj + '|' + iclass
                   Content[new_obj] = Cur_Value
                   #print "DEBUG ",new_obj," = ",Cur_Value
                   Cur_Value = ""
                Cur_Name.pop()
             elif  Bkey == 'VALUE' :
                Cur_Value = Value
             #else:
             #      print " I ignored this keyword", Bkey

   ODLtree = {}
   addname = 'ADDITIONALATTRIBUTENAME'
   delname = 'INFORMATIONCONTENT'
   for item in Content.items() :
      #print "DEBUG: ",item[0],"->",item[1] 
      Fields = string.split(item[0],'.')
      Value  = item[1];
      if ( 'ADDITIONALATTRIBUTES' in Fields  ):
         if ( delname in Fields ):
            newkey = string.join(Fields,'.')
            newkey = string.replace(newkey, \
                        'INFORMATIONCONTENT.PARAMETERVALUE',
                        'ADDITIONALATTRIBUTENAME')
            new_item = string.replace(Content[newkey],'"','') 
            ODLtree[new_item] = Value 
            #print "DEBUG2: key=",new_item,'->',Value
      elif 'ASSOCIATEDPLATFORMINSTRUMENTSENSOR' in Fields:
         i=1
      else:
         ODLtree[Fields[-1]] = Value
   return ODLtree 
         
